/* Generated by GOB (v2.0.11)   (do not edit directly) */



/*
 * libloqui -- Chat/IM client library for GLib <http://loqui.good-day.net/>
 * Copyright (C) 2005 Yoichi Imai <yoichi@silver-forest.com>
 *
 * This Library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This Library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with the Gnome Library; see the file COPYING.LIB.  If not,
 * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <glib.h>
#include <glib-object.h>
#ifndef __LOQUI_ACCOUNT_MANAGER_H__
#define __LOQUI_ACCOUNT_MANAGER_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include "loqui_account.h"
#include "loqui_channel.h"
#include "loqui_protocol_manager.h"


/*
 * Type checking and casting macros
 */
#define LOQUI_TYPE_ACCOUNT_MANAGER	(loqui_account_manager_get_type())
#define LOQUI_ACCOUNT_MANAGER(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), loqui_account_manager_get_type(), LoquiAccountManager)
#define LOQUI_ACCOUNT_MANAGER_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), loqui_account_manager_get_type(), LoquiAccountManager const)
#define LOQUI_ACCOUNT_MANAGER_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), loqui_account_manager_get_type(), LoquiAccountManagerClass)
#define LOQUI_IS_ACCOUNT_MANAGER(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), loqui_account_manager_get_type ())

#define LOQUI_ACCOUNT_MANAGER_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), loqui_account_manager_get_type(), LoquiAccountManagerClass)

/* Private structure type */
typedef struct _LoquiAccountManagerPrivate LoquiAccountManagerPrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_LOQUI_ACCOUNT_MANAGER__
#define __TYPEDEF_LOQUI_ACCOUNT_MANAGER__
typedef struct _LoquiAccountManager LoquiAccountManager;
#endif
struct _LoquiAccountManager {
	GObject __parent__;
	/*< public >*/
	LoquiProtocolManager * protocol_manager;
	gint max_channel_entry_id;
	/*< private >*/
	LoquiAccountManagerPrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _LoquiAccountManagerClass LoquiAccountManagerClass;
struct _LoquiAccountManagerClass {
	GObjectClass __parent__;
	/*signal*/void (* add_account) (LoquiAccountManager * self, LoquiAccount * account);
	/*signal*/void (* remove_account) (LoquiAccountManager * self, LoquiAccount * account);
	/*signal*/void (* add_channel_entry) (LoquiAccountManager * self, LoquiChannelEntry * chent);
	/*signal*/void (* add_channel_entry_after) (LoquiAccountManager * self, LoquiChannelEntry * chent);
	/*signal*/void (* remove_channel_entry) (LoquiAccountManager * self, LoquiChannelEntry * chent);
	/*signal*/void (* remove_channel_entry_after) (LoquiAccountManager * self, LoquiChannelEntry * chent);
};


/*
 * Public methods
 */
GType	loqui_account_manager_get_type	(void);
void 	loqui_account_manager_add_account	(LoquiAccountManager * self,
					LoquiAccount * account);
void 	loqui_account_manager_remove_account	(LoquiAccountManager * self,
					LoquiAccount * account);
void 	loqui_account_manager_add_channel_entry	(LoquiAccountManager * self,
					LoquiChannelEntry * chent);
void 	loqui_account_manager_add_channel_entry_after	(LoquiAccountManager * self,
					LoquiChannelEntry * chent);
void 	loqui_account_manager_remove_channel_entry	(LoquiAccountManager * self,
					LoquiChannelEntry * chent);
void 	loqui_account_manager_remove_channel_entry_after	(LoquiAccountManager * self,
					LoquiChannelEntry * chent);
LoquiAccountManager * 	loqui_account_manager_new	(LoquiProtocolManager * protocol_manager);
void 	loqui_account_manager_remove_all_account	(LoquiAccountManager * self);
void 	loqui_account_manager_load_accounts	(LoquiAccountManager * self);
void 	loqui_account_manager_save_accounts	(LoquiAccountManager * self);
void 	loqui_account_manager_disconnect_all	(LoquiAccountManager * self);
GList * 	loqui_account_manager_get_account_list	(LoquiAccountManager * self);
void 	loqui_account_manager_connect_all_default	(LoquiAccountManager * self);
LoquiChannelEntry * 	loqui_account_manager_get_next_channel_entry	(LoquiAccountManager * self,
					LoquiChannelEntry * chent,
					gboolean require_unread);
LoquiChannelEntry * 	loqui_account_manager_get_previous_channel_entry	(LoquiAccountManager * self,
					LoquiChannelEntry * chent,
					gboolean require_unread);
gint 	loqui_account_manager_new_channel_entry_id	(LoquiAccountManager * self);
void 	loqui_account_manager_update_positions	(LoquiAccountManager * self);

/*
 * Signal connection wrapper macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define loqui_account_manager_connect__add_account(object,func,data)	g_signal_connect(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"add_account",(GCallback) __extension__ ({void (* ___add_account) (LoquiAccountManager * ___fake___self, LoquiAccount * ___fake___account, gpointer ___data ) = (func); ___add_account; }), (data))
#define loqui_account_manager_connect_after__add_account(object,func,data)	g_signal_connect_after(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"add_account",(GCallback) __extension__ ({void (* ___add_account) (LoquiAccountManager * ___fake___self, LoquiAccount * ___fake___account, gpointer ___data ) = (func); ___add_account; }), (data))
#define loqui_account_manager_connect_data__add_account(object,func,data,destroy_data,flags)	g_signal_connect_data(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"add_account",(GCallback) __extension__ ({void (* ___add_account) (LoquiAccountManager * ___fake___self, LoquiAccount * ___fake___account, gpointer ___data ) = (func); ___add_account; }), (data), (destroy_data), (GConnectFlags)(flags))
#define loqui_account_manager_connect__remove_account(object,func,data)	g_signal_connect(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"remove_account",(GCallback) __extension__ ({void (* ___remove_account) (LoquiAccountManager * ___fake___self, LoquiAccount * ___fake___account, gpointer ___data ) = (func); ___remove_account; }), (data))
#define loqui_account_manager_connect_after__remove_account(object,func,data)	g_signal_connect_after(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"remove_account",(GCallback) __extension__ ({void (* ___remove_account) (LoquiAccountManager * ___fake___self, LoquiAccount * ___fake___account, gpointer ___data ) = (func); ___remove_account; }), (data))
#define loqui_account_manager_connect_data__remove_account(object,func,data,destroy_data,flags)	g_signal_connect_data(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"remove_account",(GCallback) __extension__ ({void (* ___remove_account) (LoquiAccountManager * ___fake___self, LoquiAccount * ___fake___account, gpointer ___data ) = (func); ___remove_account; }), (data), (destroy_data), (GConnectFlags)(flags))
#define loqui_account_manager_connect__add_channel_entry(object,func,data)	g_signal_connect(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"add_channel_entry",(GCallback) __extension__ ({void (* ___add_channel_entry) (LoquiAccountManager * ___fake___self, LoquiChannelEntry * ___fake___chent, gpointer ___data ) = (func); ___add_channel_entry; }), (data))
#define loqui_account_manager_connect_after__add_channel_entry(object,func,data)	g_signal_connect_after(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"add_channel_entry",(GCallback) __extension__ ({void (* ___add_channel_entry) (LoquiAccountManager * ___fake___self, LoquiChannelEntry * ___fake___chent, gpointer ___data ) = (func); ___add_channel_entry; }), (data))
#define loqui_account_manager_connect_data__add_channel_entry(object,func,data,destroy_data,flags)	g_signal_connect_data(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"add_channel_entry",(GCallback) __extension__ ({void (* ___add_channel_entry) (LoquiAccountManager * ___fake___self, LoquiChannelEntry * ___fake___chent, gpointer ___data ) = (func); ___add_channel_entry; }), (data), (destroy_data), (GConnectFlags)(flags))
#define loqui_account_manager_connect__add_channel_entry_after(object,func,data)	g_signal_connect(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"add_channel_entry_after",(GCallback) __extension__ ({void (* ___add_channel_entry_after) (LoquiAccountManager * ___fake___self, LoquiChannelEntry * ___fake___chent, gpointer ___data ) = (func); ___add_channel_entry_after; }), (data))
#define loqui_account_manager_connect_after__add_channel_entry_after(object,func,data)	g_signal_connect_after(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"add_channel_entry_after",(GCallback) __extension__ ({void (* ___add_channel_entry_after) (LoquiAccountManager * ___fake___self, LoquiChannelEntry * ___fake___chent, gpointer ___data ) = (func); ___add_channel_entry_after; }), (data))
#define loqui_account_manager_connect_data__add_channel_entry_after(object,func,data,destroy_data,flags)	g_signal_connect_data(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"add_channel_entry_after",(GCallback) __extension__ ({void (* ___add_channel_entry_after) (LoquiAccountManager * ___fake___self, LoquiChannelEntry * ___fake___chent, gpointer ___data ) = (func); ___add_channel_entry_after; }), (data), (destroy_data), (GConnectFlags)(flags))
#define loqui_account_manager_connect__remove_channel_entry(object,func,data)	g_signal_connect(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"remove_channel_entry",(GCallback) __extension__ ({void (* ___remove_channel_entry) (LoquiAccountManager * ___fake___self, LoquiChannelEntry * ___fake___chent, gpointer ___data ) = (func); ___remove_channel_entry; }), (data))
#define loqui_account_manager_connect_after__remove_channel_entry(object,func,data)	g_signal_connect_after(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"remove_channel_entry",(GCallback) __extension__ ({void (* ___remove_channel_entry) (LoquiAccountManager * ___fake___self, LoquiChannelEntry * ___fake___chent, gpointer ___data ) = (func); ___remove_channel_entry; }), (data))
#define loqui_account_manager_connect_data__remove_channel_entry(object,func,data,destroy_data,flags)	g_signal_connect_data(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"remove_channel_entry",(GCallback) __extension__ ({void (* ___remove_channel_entry) (LoquiAccountManager * ___fake___self, LoquiChannelEntry * ___fake___chent, gpointer ___data ) = (func); ___remove_channel_entry; }), (data), (destroy_data), (GConnectFlags)(flags))
#define loqui_account_manager_connect__remove_channel_entry_after(object,func,data)	g_signal_connect(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"remove_channel_entry_after",(GCallback) __extension__ ({void (* ___remove_channel_entry_after) (LoquiAccountManager * ___fake___self, LoquiChannelEntry * ___fake___chent, gpointer ___data ) = (func); ___remove_channel_entry_after; }), (data))
#define loqui_account_manager_connect_after__remove_channel_entry_after(object,func,data)	g_signal_connect_after(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"remove_channel_entry_after",(GCallback) __extension__ ({void (* ___remove_channel_entry_after) (LoquiAccountManager * ___fake___self, LoquiChannelEntry * ___fake___chent, gpointer ___data ) = (func); ___remove_channel_entry_after; }), (data))
#define loqui_account_manager_connect_data__remove_channel_entry_after(object,func,data,destroy_data,flags)	g_signal_connect_data(LOQUI_ACCOUNT_MANAGER(__extension__ ({LoquiAccountManager *___object = (object); ___object; })),"remove_channel_entry_after",(GCallback) __extension__ ({void (* ___remove_channel_entry_after) (LoquiAccountManager * ___fake___self, LoquiChannelEntry * ___fake___chent, gpointer ___data ) = (func); ___remove_channel_entry_after; }), (data), (destroy_data), (GConnectFlags)(flags))
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define loqui_account_manager_connect__add_account(object,func,data)	g_signal_connect(LOQUI_ACCOUNT_MANAGER(object),"add_account",(GCallback)(func),(data))
#define loqui_account_manager_connect_after__add_account(object,func,data)	g_signal_connect_after(LOQUI_ACCOUNT_MANAGER(object),"add_account",(GCallback)(func),(data))
#define loqui_account_manager_connect_data__add_account(object,func,data,destroy_data,flags)	g_signal_connect_data(LOQUI_ACCOUNT_MANAGER(object),"add_account",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define loqui_account_manager_connect__remove_account(object,func,data)	g_signal_connect(LOQUI_ACCOUNT_MANAGER(object),"remove_account",(GCallback)(func),(data))
#define loqui_account_manager_connect_after__remove_account(object,func,data)	g_signal_connect_after(LOQUI_ACCOUNT_MANAGER(object),"remove_account",(GCallback)(func),(data))
#define loqui_account_manager_connect_data__remove_account(object,func,data,destroy_data,flags)	g_signal_connect_data(LOQUI_ACCOUNT_MANAGER(object),"remove_account",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define loqui_account_manager_connect__add_channel_entry(object,func,data)	g_signal_connect(LOQUI_ACCOUNT_MANAGER(object),"add_channel_entry",(GCallback)(func),(data))
#define loqui_account_manager_connect_after__add_channel_entry(object,func,data)	g_signal_connect_after(LOQUI_ACCOUNT_MANAGER(object),"add_channel_entry",(GCallback)(func),(data))
#define loqui_account_manager_connect_data__add_channel_entry(object,func,data,destroy_data,flags)	g_signal_connect_data(LOQUI_ACCOUNT_MANAGER(object),"add_channel_entry",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define loqui_account_manager_connect__add_channel_entry_after(object,func,data)	g_signal_connect(LOQUI_ACCOUNT_MANAGER(object),"add_channel_entry_after",(GCallback)(func),(data))
#define loqui_account_manager_connect_after__add_channel_entry_after(object,func,data)	g_signal_connect_after(LOQUI_ACCOUNT_MANAGER(object),"add_channel_entry_after",(GCallback)(func),(data))
#define loqui_account_manager_connect_data__add_channel_entry_after(object,func,data,destroy_data,flags)	g_signal_connect_data(LOQUI_ACCOUNT_MANAGER(object),"add_channel_entry_after",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define loqui_account_manager_connect__remove_channel_entry(object,func,data)	g_signal_connect(LOQUI_ACCOUNT_MANAGER(object),"remove_channel_entry",(GCallback)(func),(data))
#define loqui_account_manager_connect_after__remove_channel_entry(object,func,data)	g_signal_connect_after(LOQUI_ACCOUNT_MANAGER(object),"remove_channel_entry",(GCallback)(func),(data))
#define loqui_account_manager_connect_data__remove_channel_entry(object,func,data,destroy_data,flags)	g_signal_connect_data(LOQUI_ACCOUNT_MANAGER(object),"remove_channel_entry",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define loqui_account_manager_connect__remove_channel_entry_after(object,func,data)	g_signal_connect(LOQUI_ACCOUNT_MANAGER(object),"remove_channel_entry_after",(GCallback)(func),(data))
#define loqui_account_manager_connect_after__remove_channel_entry_after(object,func,data)	g_signal_connect_after(LOQUI_ACCOUNT_MANAGER(object),"remove_channel_entry_after",(GCallback)(func),(data))
#define loqui_account_manager_connect_data__remove_channel_entry_after(object,func,data,destroy_data,flags)	g_signal_connect_data(LOQUI_ACCOUNT_MANAGER(object),"remove_channel_entry_after",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
