/* Generated by GOB (v2.0.11)   (do not edit directly) */



/*
 * libloqui -- Chat/IM client library for GLib <http://loqui.good-day.net/>
 * Copyright (C) 2004 Yoichi Imai <yoichi@silver-forest.com>
 *
 * This Library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This Library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with the Gnome Library; see the file COPYING.LIB.  If not,
 * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <glib.h>
#include <glib-object.h>
#ifndef __LOQUI_MESSAGE_TEXT_H__
#define __LOQUI_MESSAGE_TEXT_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <libloqui/loqui-gobject-utils.h>

#ifndef __TYPEDEF_LOQUI_MESSAGE_TEXT_REGION__
#define __TYPEDEF_LOQUI_MESSAGE_TEXT_REGION__
typedef struct _LoquiMessageTextRegion LoquiMessageTextRegion;
#endif

#include <libloqui/loqui-message-text-region.h>

typedef enum {
        LOQUI_TEXT_TYPE_NORMAL,
        LOQUI_TEXT_TYPE_NOTICE,
        LOQUI_TEXT_TYPE_ACTION,
        LOQUI_TEXT_TYPE_INFO,
        LOQUI_TEXT_TYPE_ERROR,
        /* private */
        LOQUI_TEXT_TYPE_TIME,
        LOQUI_TEXT_TYPE_URI,
        LOQUI_TEXT_TYPE_EMPHASIS,
        LOQUI_TEXT_TYPE_TRANSPARENT,
} LoquiTextType;


/*
 * Type checking and casting macros
 */
#define LOQUI_TYPE_MESSAGE_TEXT	(loqui_message_text_get_type())
#define LOQUI_MESSAGE_TEXT(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), loqui_message_text_get_type(), LoquiMessageText)
#define LOQUI_MESSAGE_TEXT_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), loqui_message_text_get_type(), LoquiMessageText const)
#define LOQUI_MESSAGE_TEXT_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), loqui_message_text_get_type(), LoquiMessageTextClass)
#define LOQUI_IS_MESSAGE_TEXT(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), loqui_message_text_get_type ())

#define LOQUI_MESSAGE_TEXT_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), loqui_message_text_get_type(), LoquiMessageTextClass)

/*
 * Main object structure
 */
#ifndef __TYPEDEF_LOQUI_MESSAGE_TEXT__
#define __TYPEDEF_LOQUI_MESSAGE_TEXT__
typedef struct _LoquiMessageText LoquiMessageText;
#endif
struct _LoquiMessageText {
	GObject __parent__;
	/*< public >*/
	LoquiTextType text_type;
	gchar * text;
	gchar * channel_name;
	gchar * account_name;
	gchar * nick;
	gboolean is_self;
	gboolean is_priv;
	gboolean is_remark;
	gboolean is_ignored;
	GList * highlight_region_list;
	GList * uri_region_list;
};

/*
 * Class definition
 */
typedef struct _LoquiMessageTextClass LoquiMessageTextClass;
struct _LoquiMessageTextClass {
	GObjectClass __parent__;
};


/*
 * Public methods
 */
GType	loqui_message_text_get_type	(void);
gchar * 	loqui_message_text_get_nick_string	(LoquiMessageText * self,
					gboolean with_channel_name);
LoquiMessageText * 	loqui_message_text_new	(void);
gboolean 	loqui_message_text_get_has_highlight_keyword	(LoquiMessageText * self);

/*
 * Argument wrapping macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define LOQUI_MESSAGE_TEXT_PROP_TEXT(arg)    	"text", __extension__ ({gchar *z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_GET_PROP_TEXT(arg)	"text", __extension__ ({gchar **z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_PROP_CHANNEL_NAME(arg)    	"channel_name", __extension__ ({gchar *z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_GET_PROP_CHANNEL_NAME(arg)	"channel_name", __extension__ ({gchar **z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_PROP_ACCOUNT_NAME(arg)    	"account_name", __extension__ ({gchar *z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_GET_PROP_ACCOUNT_NAME(arg)	"account_name", __extension__ ({gchar **z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_PROP_NICK(arg)    	"nick", __extension__ ({gchar *z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_GET_PROP_NICK(arg)	"nick", __extension__ ({gchar **z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_PROP_IS_SELF(arg)    	"is_self", __extension__ ({gboolean z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_GET_PROP_IS_SELF(arg)	"is_self", __extension__ ({gboolean *z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_PROP_IS_PRIV(arg)    	"is_priv", __extension__ ({gboolean z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_GET_PROP_IS_PRIV(arg)	"is_priv", __extension__ ({gboolean *z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_PROP_IS_REMARK(arg)    	"is_remark", __extension__ ({gboolean z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_GET_PROP_IS_REMARK(arg)	"is_remark", __extension__ ({gboolean *z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_PROP_IS_IGNORED(arg)    	"is_ignored", __extension__ ({gboolean z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_GET_PROP_IS_IGNORED(arg)	"is_ignored", __extension__ ({gboolean *z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_PROP_TEXT_TYPE(arg)    	"text_type", __extension__ ({guint z = (arg); z;})
#define LOQUI_MESSAGE_TEXT_GET_PROP_TEXT_TYPE(arg)	"text_type", __extension__ ({guint *z = (arg); z;})
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define LOQUI_MESSAGE_TEXT_PROP_TEXT(arg)    	"text",(gchar *)(arg)
#define LOQUI_MESSAGE_TEXT_GET_PROP_TEXT(arg)	"text",(gchar **)(arg)
#define LOQUI_MESSAGE_TEXT_PROP_CHANNEL_NAME(arg)    	"channel_name",(gchar *)(arg)
#define LOQUI_MESSAGE_TEXT_GET_PROP_CHANNEL_NAME(arg)	"channel_name",(gchar **)(arg)
#define LOQUI_MESSAGE_TEXT_PROP_ACCOUNT_NAME(arg)    	"account_name",(gchar *)(arg)
#define LOQUI_MESSAGE_TEXT_GET_PROP_ACCOUNT_NAME(arg)	"account_name",(gchar **)(arg)
#define LOQUI_MESSAGE_TEXT_PROP_NICK(arg)    	"nick",(gchar *)(arg)
#define LOQUI_MESSAGE_TEXT_GET_PROP_NICK(arg)	"nick",(gchar **)(arg)
#define LOQUI_MESSAGE_TEXT_PROP_IS_SELF(arg)    	"is_self",(gboolean )(arg)
#define LOQUI_MESSAGE_TEXT_GET_PROP_IS_SELF(arg)	"is_self",(gboolean *)(arg)
#define LOQUI_MESSAGE_TEXT_PROP_IS_PRIV(arg)    	"is_priv",(gboolean )(arg)
#define LOQUI_MESSAGE_TEXT_GET_PROP_IS_PRIV(arg)	"is_priv",(gboolean *)(arg)
#define LOQUI_MESSAGE_TEXT_PROP_IS_REMARK(arg)    	"is_remark",(gboolean )(arg)
#define LOQUI_MESSAGE_TEXT_GET_PROP_IS_REMARK(arg)	"is_remark",(gboolean *)(arg)
#define LOQUI_MESSAGE_TEXT_PROP_IS_IGNORED(arg)    	"is_ignored",(gboolean )(arg)
#define LOQUI_MESSAGE_TEXT_GET_PROP_IS_IGNORED(arg)	"is_ignored",(gboolean *)(arg)
#define LOQUI_MESSAGE_TEXT_PROP_TEXT_TYPE(arg)    	"text_type",(guint )(arg)
#define LOQUI_MESSAGE_TEXT_GET_PROP_TEXT_TYPE(arg)	"text_type",(guint *)(arg)
#endif /* __GNUC__ && !__STRICT_ANSI__ */



LOQUI_DEFINE_ACCESSOR_CONST_STRING_PROTOTYPE(LoquiMessageText, loqui_message_text, text);
LOQUI_DEFINE_ACCESSOR_CONST_STRING_PROTOTYPE(LoquiMessageText, loqui_message_text, nick);
LOQUI_DEFINE_ACCESSOR_CONST_STRING_PROTOTYPE(LoquiMessageText, loqui_message_text, account_name);
LOQUI_DEFINE_ACCESSOR_CONST_STRING_PROTOTYPE(LoquiMessageText, loqui_message_text, channel_name);

LOQUI_DEFINE_ACCESSOR_GENERIC_PROTOTYPE(LoquiMessageText, loqui_message_text, is_self, gboolean);
LOQUI_DEFINE_ACCESSOR_GENERIC_PROTOTYPE(LoquiMessageText, loqui_message_text, is_priv, gboolean);
LOQUI_DEFINE_ACCESSOR_GENERIC_PROTOTYPE(LoquiMessageText, loqui_message_text, is_remark, gboolean);
LOQUI_DEFINE_ACCESSOR_GENERIC_PROTOTYPE(LoquiMessageText, loqui_message_text, is_ignored, gboolean);

LOQUI_DEFINE_ACCESSOR_GENERIC_PROTOTYPE(LoquiMessageText, loqui_message_text, text_type, LoquiTextType);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
